<template>
  <div>
    <v-list
      v-for="(item, index) in value"
      :key="index"
      two-line
      style="overflow-x: auto; max-height: 28rem"
      class="pa-0"
    >
      <v-list-item
        style="background-color: #f5f5f5; min-height: 110px; border-radius: 5px"
        class="mt-4"
      >
        <div v-if="item.mimeType._text.startsWith(`image/`)" class="mr-4">
          <a
            @click.prevent="
              downloadFile(
                `data:${item.mimeType._text};base64,${item.dataBase64._text}`,
                item.fileName._text
              )
            "
          >
            <v-img
              max-height="100"
              max-width="100"
              :src="`data:${item.mimeType._text};base64,${item.dataBase64._text}`"
            ></v-img>
          </a>
        </div>
        <v-list-item-avatar v-else width="100">
          <v-icon style="font-size: 40px">{{
            getFileIcon(item.fileName._text)
          }}</v-icon>
        </v-list-item-avatar>
        <v-list-item-content class="pt-6">
          <v-list-item-title
            ><a
              @click.prevent="
                downloadFile(
                  `data:${item.mimeType._text};base64,${item.dataBase64._text}`,
                  item.fileName._text
                )
              "
              >{{ $t("dcc.common.richContentType.file") }}</a
            ><span style="font-size: small">
              ({{ item.mimeType._text }})
            </span></v-list-item-title
          >
          <v-row>
            <v-col cols="12" md="6">
              <GTextField
                v-model="item.fileName._text"
                i18n="dcc.common.richContentType.fileName"
                validate="notEmptyStringType"
              />
            </v-col>
            <v-col cols="12" md="6">
              <GTextField
                v-model="item._attr.refType"
                i18n="dcc.common.attributes.refType"
                attr-ref-type
              />
            </v-col>
          </v-row>
        </v-list-item-content>
        <v-list-item-action>
          <v-tooltip bottom>
            <template #activator="{ on }">
              <v-btn icon v-on="on" @click="deleteFromArray(index)">
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </template>
            <span>{{ $t("dcc.common.richContentType.deleteFile") }}</span>
          </v-tooltip>
        </v-list-item-action>
      </v-list-item>
    </v-list>
  </div>
</template>

<script>
import { downloadFile, getFileIcon } from "assets/util/general";
import GTextField from "~/components/App/Form/gTextField";

export default {
  name: "GFileItem",
  components: { GTextField },
  props: {
    value: Array,
  },
  methods: {
    getFileIcon(fileName) {
      return getFileIcon(fileName);
    },
    downloadFile(item, fileName) {
      downloadFile(item, fileName);
    },
    deleteFromArray(index) {
      if (!confirm(this.$t("dcc.common.richContentType.confirmRemoveFile"))) {
        return;
      }
      this.value.splice(index, 1);
      if (this.value.length === 0) {
        this.$emit("input", undefined);
      }
    },
  },
};
</script>
